Package tigase.xmpp.impl

# Class BlockingCommand

java.lang.Object
tigase.xmpp.XMPPProcessor
tigase.xmpp.impl.annotation.AnnotatedXMPPProcessor
tigase.xmpp.XMPPProcessorAbstract
tigase.xmpp.impl.BlockingCommand

All Implemented Interfaces:
  `Comparable<XMPPImplIfc>`, `XMPPImplIfc`, `XMPPProcessorConcurrencyAwareIfc`, `XMPPProcessorIfc`

@Bean(name="urn:xmpp:blocking", parent=SessionManager.class, active=true) public class BlockingCommand extends XMPPProcessorAbstract implements XMPPProcessorIfc
XEP-0191: Blocking Command. Based on privacy lists.

Author:
  Andrzej Wójcik
  Originally submitted by:, Daniele Ricci, Behnam Hatami

- ## Field Summary

  Fields
  Modifier and Type
  Field
  Description
  `protected static final String`
  `BLOCK`
  `protected static final String`
  `BLOCKLIST`
  `protected static final String`
  `ID`
  `protected static final String`
  `UNBLOCK`
  `protected static final String`
  `XMLNS`
  `protected static final String`
  `XMLNS_ERRORS`

  ### Fields inherited from class tigase.xmpp.XMPPProcessor

  `ALL_NAMES, ALL_PATHS, cmpInfo`

  ### Fields inherited from interface tigase.xmpp.XMPPImplIfc

  `CLIENT_XMLNS`

- ## Constructor Summary

  Constructors
  Constructor
  Description
  `BlockingCommand()`

- ## Method Summary

  Modifier and Type
  Method
  Description
  `void`
  `process(Packet packet, XMPPResourceConnection session, NonAuthUserRepository repo, Queue<Packet> results, Map<String,Object> settings)`
  `void`
  `processFromUserToServerPacket(JID connectionId, Packet packet, XMPPResourceConnection session, NonAuthUserRepository repo, Queue<Packet> results, Map<String,Object> settings)`
  The method is called when a packet is send from the user who is owner of the session to the local server (ping, roster management, privacy lists, etc...).
  `void`
  `processServerSessionPacket(Packet packet, XMPPResourceConnection session, NonAuthUserRepository repo, Queue<Packet> results, Map<String,Object> settings)`
  The method is called when a packet addressed to the server domain is received.
  `void`
  `setSpamReportsConsumers(List<SpamReportsConsumer> spamReportsConsumers)`
  `Element[]`
  `supDiscoFeatures(XMPPResourceConnection session)`
  Method `supDiscoFeatures` returns an array of XML `Element`s with service discovery features which have to be returned to the client uppon request.

  ### Methods inherited from class tigase.xmpp.XMPPProcessorAbstract

  `isFromUserSession, isNullSession, isServerSession, isToUserSession, processFromUserOutPacket, processFromUserPacket, processNullSessionPacket, processToUserPacket`

  ### Methods inherited from class tigase.xmpp.impl.annotation.AnnotatedXMPPProcessor

  `id, supElementNamePaths, supNamespaces, supStreamFeatures, supTypes`

  ### Methods inherited from class tigase.xmpp.XMPPProcessor

  `canHandle, compareTo, concurrentQueuesNo, getComponentInfo, getInstance, getQueueSize, getStatistics, getThreadsNo, init, toString`

  ### Methods inherited from class java.lang.Object

  `clone, equals, finalize, getClass, hashCode, notify, notifyAll, wait, wait, wait`

  ### Methods inherited from interface java.lang.Comparable

  `compareTo`

  ### Methods inherited from interface tigase.xmpp.XMPPImplIfc

  `canHandle, concurrentQueuesNo, getComponentInfo, getStatistics, id, init, supElementNamePaths, supNamespaces, supStreamFeatures, supTypes`

- ## Field Details

  - ### XMLNS

    protected static final String XMLNS
    See Also:
      - Constant Field Values

  - ### XMLNS_ERRORS

    protected static final String XMLNS_ERRORS
    See Also:
      - Constant Field Values

  - ### ID

    protected static final String ID
    See Also:
      - Constant Field Values

  - ### BLOCKLIST

    protected static final String BLOCKLIST
    See Also:
      - Constant Field Values

  - ### BLOCK

    protected static final String BLOCK
    See Also:
      - Constant Field Values

  - ### UNBLOCK

    protected static final String UNBLOCK
    See Also:
      - Constant Field Values

- ## Constructor Details

  - ### BlockingCommand

    public BlockingCommand()

- ## Method Details

  - ### supDiscoFeatures

    public Element[] supDiscoFeatures(XMPPResourceConnection session)
    Description copied from interface: `XMPPImplIfc`
    Method `supDiscoFeatures` returns an array of XML `Element`s with service discovery features which have to be returned to the client uppon request. Service discovery features returned by this method correspond to services supported by this plugin.
    Specified by:
      `supDiscoFeatures` in interface `XMPPImplIfc`
    Overrides:
      `supDiscoFeatures` in class `AnnotatedXMPPProcessor`
    Parameters:
      `session` - a `XMPPResourceConnection` value
    Returns:
      an `Element[]` value

  - ### setSpamReportsConsumers

    public void setSpamReportsConsumers(List<SpamReportsConsumer> spamReportsConsumers)

  - ### process

    public void process(Packet packet, XMPPResourceConnection session, NonAuthUserRepository repo, Queue<Packet> results, Map<String,Object> settings) throws XMPPException
    Specified by:
      `process` in interface `XMPPProcessorIfc`
    Overrides:
      `process` in class `XMPPProcessorAbstract`
    Parameters:
      `packet` - packet is which being processed. This parameter may never be null. Even though this is not immutable object it mustn't be altered. None of it's fields or attributes can be changed during processing.
      `session` - user session which keeps all the user session data and also gives an access to the user's repository data. It allows for storing information in a permanent storage or in memory only during the live of the online session. This parameter can be null if there is no online user session at the time of the packet processing.
      `repo` - this is a user data storage which is normally used when the user session (parameter above) is null. This is repository allows for a very restricted access only. It allows for storing some user private data (doesn't allow overwriting existing data) like messages for offline users and it also allows for reading user public data like VCard.
      `results` - this a collection with packets which have been generated as input packet processing results. Regardless a response to a user request is sent or the packet is forwarded to it's destination it is always required that a copy of the input packet is created and stored in the results queue.
      `settings` - this map keeps plugin specific settings loaded from the Tigase server configuration. In most cases it is unused, however if the plugin needs to access an external database that this is a way to pass database connection string to the plugin.
    Throws:
      `XMPPException`

  - ### processFromUserToServerPacket

    public void processFromUserToServerPacket(JID connectionId, Packet packet, XMPPResourceConnection session, NonAuthUserRepository repo, Queue<Packet> results, Map<String,Object> settings) throws PacketErrorTypeException
    Description copied from class: `XMPPProcessorAbstract`
    The method is called when a packet is send from the user who is owner of the session to the local server (ping, roster management, privacy lists, etc...). There is no default implementation for the method.
    Specified by:
      `processFromUserToServerPacket` in class `XMPPProcessorAbstract`
    Parameters:
      `connectionId` - is a `JID` instance with the session connection ID.
      `packet` - is a `Packet` sent by the user.
      `session` - is a `XMPPResourceConnection` instance with all the sending user session data.
      `repo` - is a `NonAuthUserRepository` instance giving access to a part of the user repository which is accessible regardless the session is authenticated or not.
      `results` - is a packets `Queue` with all the processing results from the plugin.
      `settings` - is a `Map` with all the configuration settings passed to the plugin.
    Throws:
      `PacketErrorTypeException` - on attempt to send an error response to the error packet.

  - ### processServerSessionPacket

    public void processServerSessionPacket(Packet packet, XMPPResourceConnection session, NonAuthUserRepository repo, Queue<Packet> results, Map<String,Object> settings) throws PacketErrorTypeException
    Description copied from class: `XMPPProcessorAbstract`
    The method is called when a packet addressed to the server domain is received. Please note, if a local user sends a packet to the server, the packet is handled by the `processFromUserPacket(...)` method. This method is not called for such packets.
    Specified by:
      `processServerSessionPacket` in class `XMPPProcessorAbstract`
    Parameters:
      `packet` - is a `Packet` received by the server and addressed to the server - the server virtual domain name.
      `session` - is a `XMPPResourceConnection` instance with all the server session data.
      `repo` - is a `NonAuthUserRepository` instance giving access to a part of the user repository which is accessible regardless the session is authenticated or not.
      `results` - is a packets `Queue` with all the processing results from the plugin.
      `settings` - is a `Map` with all the configuration settings passed to the plugin.
    Throws:
      `PacketErrorTypeException` - on attempt to send an error response to the error packet.